var framecount  = 0;
var if_time     = 000;
var interval    = 2000;
var maxframes   = 3000;
var started     = 0;
var timer       = null;

/*
 * camera indices:
 *
 * 0->pandas
 * 1->elephants
 * 2->polar bears
 * 3->apes
 */
var cameraIndex = 0;
var maxCameras = 3;
var active = 0;

/*
 * main activation 
 */
function setup() {
    if(window.widget) {
        widget.onshow = onshow;
        widget.onhide = onhide;
    }
    loadPreferences();
    onshow();
    createGenericButton(document.getElementById('done'), "Done", hideBack);

    if(!widget.preferenceForKey("versionChecked")) {
        versionCheck(3);
        widget.setPreferenceForKey(1, "versionChecked");
    } else {
        versionCheck(1);
    }
}

function loadPreferences() {
    if(window.widget) {
        var index = widget.preferenceForKey("cameraIndex");
        if(!(index && index >=0 && index <= maxCameras)) {
            index = 0;
        }
        selectWebcam(index);
    }
}
function savePreferences() {
    if(window.widget) {
        widget.setPreferenceForKey(cameraIndex, "cameraIndex");
    }
}

/* 
 *main functions
 */
function updateImage(obj) {
    var now = new Date();
    framecount += 1;
    secs = now.getTime();
    if (framecount <= maxframes) {
        var camzone = "http://pandaos.camzone.com:8879/still?cam="+cameraIndex+"&i=" + framecount + ":" + secs + ":" + if_time;
        obj.src = camzone;
    } else {
        var camzone = "http://www.camzone.com/trailer.jpg";
        obj.src = camzone;
        framecount = -1;
        return;
    }
}
function update() {
    if(active) {
        updateImage(document.webcam);
    }
}
function selectWebcam(num) {
    // remove selected property from previous webcam
    e = document.getElementById('selector'+cameraIndex);
    e.className = e.className.replace(/ ?selected/i, '');

    // change cameras
    cameraIndex = num;
    savePreferences();

    // set selected property for new webcam
    e = document.getElementById('selector'+cameraIndex);
    e.className = e.className + " selected";

    update();
}
function versionCheck(version) {
    url = "http://www.courtah.net/builds/panda_cam_version.php?version="+version;
    req = new XMLHttpRequest();
    req.open("GET", url, true);
    req.send(null);
}

/*
 * flip button
 */
var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null}; 

function mousemove (event) 
{ 
    if (!flipShown) 
    { 
        if (animation.timer != null) 
        { 
            clearInterval (animation.timer); 
            animation.timer  = null; 
        } 
        var starttime = (new Date).getTime() - 13; 
        animation.duration = 500; 
        animation.starttime = starttime; 
        animation.firstElement = document.getElementById ('flip'); 
        animation.timer = setInterval ("animate();", 13); 
        animation.from = animation.now; 
        animation.to = 1.0; 
        animate(); 
        flipShown = true; 
    } 
} 
function mouseexit (event) 
{ 
    if (flipShown) 
    { 
        // fade in the info button 
        if (animation.timer != null) 
        { 
            clearInterval (animation.timer); 
            animation.timer  = null; 
        } 
        var starttime = (new Date).getTime() - 13; 
        animation.duration = 500; 
        animation.starttime = starttime; 
        animation.firstElement = document.getElementById ('flip'); 
        animation.timer = setInterval ("animate();", 13); 
        animation.from = animation.now; 
        animation.to = 0.0; 
        animate(); 
        flipShown = false; 
    } 
} 
function animate() 
{ 
    var T; 
    var ease; 
    var time = (new Date).getTime(); 
    T = limit_3(time-animation.starttime, 0, animation.duration); 
    if (T >= animation.duration) 
    { 
        clearInterval (animation.timer); 
        animation.timer = null; 
        animation.now = animation.to; 
    } 
    else 
    { 
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration)); 
        animation.now = computeNextFloat (animation.from, animation.to, ease); 
    } 
    animation.firstElement.style.opacity = animation.now; 
} 
function limit_3 (a, b, c) 
{ 
    return a < b ? b : (a > c ? c : a); 
} 
function computeNextFloat (from, to, ease) 
{ 
    return from + (to - from) * ease; 
} 
function enterflip(event) 
{ 
    document.getElementById('fliprollie').style.display = 'block'; 
} 
function exitflip(event) 
{ 
    document.getElementById('fliprollie').style.display = 'none'; 
} 


/*
 * dashboard flipping functions
 */
function showBack() 
{ 
    var front = document.getElementById("front"); 
    var back = document.getElementById("back"); 
    if (window.widget) 
        widget.prepareForTransition("ToBack"); 
    front.style.display="none"; 
    back.style.display="block"; 
    if (window.widget) 
        setTimeout ('widget.performTransition();', 0);  
    document.getElementById('fliprollie').style.display = 'none';
} 

function hideBack() 
{ 
    var front = document.getElementById("front"); 
    var back = document.getElementById("back"); 
    if (window.widget) 
        widget.prepareForTransition("ToFront"); 
    back.style.display="none"; 
    front.style.display="block"; 
    if (window.widget) 
        setTimeout ('widget.performTransition();', 0); 
} 

/*
 * dashboard events
 */
function onshow() {
    if(active == 0) {
        active = 1;
        framecount = 0;
        update();
    }
    versionCheck(2);
    /*
    if( timer == null ) {
        update();
        timer = setInterval("update();", interval);
    }
    */
}

function onhide() {
    if(active == 1) {
        active = 0;
        framecount = 0;
    }
    /*
    if(timer != null) {
        clearInterval(timer);
        timer = null;
    }
    */
}

